/*****************

  ȿߥ졼ܺ

  reaction.c

  ******************/

#include "test.h"

/* ------------------------------------------------
  Ǯưǡ*/

void t_motion(struct PARTICLE *currentP){

  double dx,dy;
  double x,y;

  dx=randoms()/10;
  dy=randoms()/10;
  /* printf("dx = %lf, dy = %lf \n",dx,dy); */

  x=currentP->x + dx;
  y=currentP->y + dy;

  if(x<0) x*=-1;
  if(y<0) y*=-1;
  if(x>MAX_X) x = MAX_X*2-x;
  if(y>MAX_X) y = MAX_Y*2-y;

  currentP->x = x;
  currentP->y = y;

  currentP->state *= -1;

}

void around_check(struct AROUND *currentA, struct PARTICLE *currentP, struct BCELL *startBC){

  double currentx, currenty;
  int fx,fy;
  int xh,xl,yh,yl;
  int flug;
  int i,j,k;
  double tempx,tempy;
  double rx,ry;
  int realx, realy;

  currentx=currentP->x;
  currenty=currentP->y;

  fx = floor(currentx);
  fy = floor(currenty);
 
  for(i=0;i<3;i++){
    for(j=0;j<3;j++){
      currentA->bcell[i][j]=NULL;
    }
  }

  currentA->rangexh = currentx+RUDIUS;
  currentA->rangexl = currentx-RUDIUS;
  currentA->rangeyh = currenty+RUDIUS;
  currentA->rangeyl = currenty-RUDIUS;

  if(currentA->rangexh > MAX_X){
    currentA->rangexh = MAX_X;
  }
  else if(currentA->rangexl < 0){
    currentA->rangexl = 0;
  }

  if(currentA->rangeyh > MAX_Y){
    currentA->rangeyh = MAX_Y;
  }
  else if(currentA->rangeyl < 0){
    currentA->rangeyl = 0;
  }
 
  xh=xl=yh=yl=0;
 
  if((currentx+RUDIUS > fx+1) && (currentx+RUDIUS < MAX_X)){
    xh=1;
  }
  else if((currentx-RUDIUS < fx) && (currentx-RUDIUS > 0)){
    xl=-1;
  }
  
  if((currenty+RUDIUS > fy+1) && (currenty+RUDIUS < MAX_Y)){
    yh=1;
  }
  else if((currenty-RUDIUS < fy) && (currenty-RUDIUS > 0)){
    yl=-1;
  }

  for(i=xl;i<=xh;i++){
    for(j=yl;j<=yh;j++){
      
      flug = 1;
      realx = i+fx;
      realy = j+fy;

      if((i != 0) && (j != 0)){
	
	if(i==1)
	  tempx=floor(currentx) + 1;
	else
	  tempx = floor(currentx);
	if(j==1)
	  tempy=floor(currenty) + 1;
	else
	  tempy = floor(currenty);
	
	tempx = currentx - tempx;
	tempy = currenty - tempy;
	
	if(RUDIUS*RUDIUS < tempx*tempx + tempy*tempy)
	  flug = 0;
      }
	
      if(flug != 0){
	currentA->bcell[i+1][j+1]=find_BCELL(realx, realy, startBC);
	
      }

    }
  }
      

}

void reaction_check(struct AROUND *currentA, struct PARTICLE *currentP, struct BCELL *start){

  /* ѿ */

  int c_index[20];
  int i,j,k,tempstate;
  struct PARTICLE *tempP;
  struct BCELL *tempBC;
  double tempx,tempy, currentx,currenty;
  double dx,dy;
  double square;
  double xh,xl,yh,yl;
  struct PARTICLE *P_index[20][300];
  int flug1,flug2;
  int pointer_num[20];
  int formula;

  unsigned char equation[EQ_NUM][2][20] =
  {
    {
      /* 1 */
      {0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
      {0,2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
    },
   {
      /* 2 */
      {0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
      {0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
    },
    {
      /* 3 */
      {0,0,0,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
      {0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
    },
   
    {
      /* 4 */
      {0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
      {0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
    }

   
  };
  
  int rtimes = 10;
  int rtemp;

  /* ޤǤѿʹߤ */

  /* ޤϼϤPARTICLEο夲 */

  square = RUDIUS * RUDIUS;

  currentx = currentP->x;
  currenty = currentP->y;

  xh = currentA->rangexh;
  xl = currentA->rangexl;
  yh = currentA->rangeyh;
  yl = currentA->rangeyl;

  for(i=0;i<20;i++){
    c_index[i]=0;
    for(j=0;j<200;j++){
      P_index[i][j]=NULL;
    }
  }

  for(i=0;i<3;i++){
    for(j=0;j<3;j++){

      tempBC=currentA->bcell[i][j];

      if(tempBC != NULL){

	tempP=tempBC->pnext;

	while(tempP != NULL){
	  
	  if(tempP != currentP){

	    tempx = tempP->x;
	    tempy = tempP->y;
	    
	    if(tempx <= xh && tempx >= xl && tempy <= yh && tempy >= yl){
	      
	      dx = currentx - tempx;
	      dy = currenty - tempy;
	      
	      if(dx*dx + dy*dy < square){
		
		tempstate = abs(tempP->state);
		
		P_index[tempstate][c_index[tempstate]] = tempP;
		c_index[tempstate]++;
		
	      }
	      
	    }
	    
	  }
	  
	  tempP = tempP->next;
	  
	}
	
      }
      
    }

  }

  /* ޤǤ夲*/

 
  for(i=0;i<20;i++){
    /*printf("%d ",c_index[i]);*/
 
    /*pointer_num[i]=0;*/
  }
  /*printf("\n");*/
 

  /* 餬ȿΡ
     ȿ򤷤ߤĤ֤ˤ롣*/

  for(rtemp=0;rtemp<rtimes;rtemp++){

  for(i=0;i<1;i++){
    /*for(i=0;i<EQ_NUM;i++){*/
    flug1=1;
    flug2=1;
    formula = randomint(4);

    for(j=0;j<20;j++){
      if(equation[formula][0][j] > c_index[j]){
	flug1 = 0;
      }
      if(c_index[j] != 0){
	flug2 = 0;
      }
    }

    /* ⤷ȿ˹礦ʤаʲνԤ */

    if(flug1==1 && flug2 == 0){

      for(j=0;j<20;j++){
	for(k=0;k<equation[formula][0][j];k++){
	  
	  /* printf("d ID %d(%d) ",j,k+1);*/
	  c_index[j]--;
	  if(P_index[j][c_index[j]] == NULL){
	    printf("error!!\n");
	  }
	  delete_list(P_index[j][c_index[j]],start);
	 

	  
	}
      }

      for(j=0;j<20;j++){
	for(k=0;k<equation[formula][1][j];k++){
	  
	  /* printf("c ID %d(%d) ",j,k+1); */

	  add_PARTICLE(j,currentx+randoms()/10, currenty+randoms()/10, start);

	  /* ɲä줿PARTICLEȿʤäơ
	     c_index[]䤵ʤ*/

	 
	  /*P_index[j][c_index[j]] = tempP;
	  c_index[j]++;*/

	  

	}

      }

    }

  }

  }

  /* ޤǤȿΡ */



}

